import './Leaderboard.css';
import React from 'react';

export default function Leaderboard({ players }) {
  const tableRows = Object.keys(players.leaderboard).map(name => {
    var rank = players.leaderboard[name];

    return (
      <tr key={name} className={players.user.isCurrentUser(name) && 'currentuser'}>
        <td>{name}</td>
        <td>{rank.total}</td>
        <td>{rank.victory}</td>
        <td>{rank.draw}</td>
      </tr>
    )
  });

  return (
    <div className='Leaderboard'>
      <table>
        <thead>
          <tr>
            <th></th>
            <th>Total</th>
            <th>Victory</th>
            <th>Draw</th>
          </tr>
        </thead>
        <tbody>
          {tableRows}
        </tbody>
      </table>
    </div>
  )
};